/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package producentkonzument2;


/**
 *
 * @author balikm1
 */
public class Konzument implements Runnable {

    private final Sklad s;
    private int cislo;

    public Konzument(Sklad s, int cislo)
    {
        this.s = s;
        this.cislo = cislo;
    }

    public void run() {
        boolean otevreno = true;
        synchronized(s)
        {
            otevreno = s.isSkladOtevren();
        }
        while (otevreno)
        {
            synchronized (s)
            {
                while(s.isEmpty() && s.isSkladOtevren())
                {
                    System.out.println("Sklad je prazdny, cekam...");
                    try {
                        s.wait();
                    } catch (InterruptedException ex) {
                        System.out.println("Konzument" + cislo + ": Doslo k preruseni.");
                    }
                }
                System.out.println("Konzument" + cislo + ": Ze skladu jsem vyzvedl polozku " + s.get());
                otevreno = s.isSkladOtevren();
                s.notifyAll();
                Thread.yield();
            }
        }
        
    }

}
