/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package producentkonzument2;


/**
 *
 * @author balikm1
 */
public class Producent implements Runnable {

    private final Sklad s;
    private int counter;
    private int cislo;

    public Producent(Sklad s, int cislo)
    {
        this.s = s;
        this.cislo = cislo;
        counter = 0;
    }

    public void run() {
        boolean otevreno = true;
        synchronized(s)
        {
            otevreno = s.isSkladOtevren();
        }
        while (otevreno)
        {
            synchronized (s)
            {
                int polozka = counter++;
                System.out.println("Producent" + cislo + ": Vyprodukoval jsem polozku " + polozka + " a pokusim se ji vlozit do skladu.");
                while (s.isFull() && s.isSkladOtevren())
                {
                    System.out.println("Producent" + cislo + ": Sklad je plny, cekam...");
                    try {
                        s.wait();
                    } catch (InterruptedException ex) {
                        System.out.println("Producent" + cislo + ": Doslo k preruseni.");
                    }
                }
                s.put(polozka);
                otevreno = s.isSkladOtevren();
                s.notifyAll();
                Thread.yield();
            }
            
        }
    }

}
